/**
 * Victor Silva - University of Bridgeport 20 Feb. 1997
 * D.L. Modified heavily for object orientation...8/10/97
 * Use this class by calling CMY.fromRGB to convert a
 * double array containing image pixels into CMY color space.
 *
 * Alternatively call CMY.toRGB to convert from CMY to
 * RGB.
 *
 * CMY and RGB Converter class.  This class allows conversion
 * between RGB and CMY (Cyan, Magenta, Yellow).
 * The conversion algorithm is from Foley and van Dam
 * "Computer Graphics".
 * 
 */
package VS;
import ipl.*;

public class CMY extends ColorConverter {

public CMY ( ProcessPlane pp_) {
	super(pp_);
}
public int[] fromRGB() {

      for (int i=0; i < fi.r.length; i++) {
         fi.r[i] = 1 - fi.r[i];
         fi.g[i] = 1 - fi.g[i];
         fi.b[i] = 1 - fi.b[i];
         pp.setPixel(i, (int) fi.r[i], (int) fi.g[i], (int)fi.b[i], 255);
      }

      return(pp.pels); 
}

public int[] toRGB() {
	return fromRGB();
 }

}

