package lyon;
import java.awt.*;
import java.io.*;
import java.net.*;
import htmlconverter.*;
import net.*;
import ipl.*;
import gui.*;
import threads.*;
import lyon.audio.*;
import futils.*;
import futils.utils.*;


public class MenuBarFrame extends AppletHandlerFrame  {
	MenuBar menuBar;
	String str;
	
	private String science_items [] = {
			"Image Processing","-",
			"Audio Processing",
			"Open Vectors",
			"save as pict"
	};
	private String batch_items [] = {
		"lyon.surfer.Surface",
		"benchmark",
		"Thread Monitor",
		"-",
		"Toy Calculator",
		"Fonts",
		"-",
		"net.SearchDNS",
		"CheckMail",
		"SendMail",
		"-",
		"dump_class",
		"list properties",
		//"mocha.Decompiler",
		"-",
		"filter_file_hrefs",
		"parse_commands",
		"process_java",
		"-",
		"BATCH PROCESSING",
		"-",
		"filter_htmls",
		"make_toc_html",
		"htmlGenerator",
		
	};
	
	private String ls_items [] = {
		"cat *.java",
		"ls",
		"ls */*>foo",
		"ls word print merge",
		"delete class files",
		"ls_htmls",
		"ls_javas",
		"ls_gifs",
		"list_dirs",
		"find it"
	};
	
	private String cad_items [] = {
		"Lambda","-",
		"ax**+x/2+c","-",	
		"list_set_up",
		"open",
		"save",
		"Grid","step size",
		"-","F","A","rotation"
		};
	
	private String colors [] = {
		"white",
		"red",
		"green",
		"blue",
		"pink",
		"-",
		"color grid",
		"color camera",
		"color laser",
		"color wedge",
		"color grating",
		"-",
		"Grid toggle"
		};
	
	private String instructions[] = {
		"4=left,6=right",
		"7=up+left,9=up+right",
		"8=up,2=down",
		"1=down+left,3=down+right",
		"+=zoom in, -=zoomout",
		"type: p to print geometry",
		"type: a to print angles",
		"type: d to print dl vs x",
		"dragging wedge rotates laser",
		"Graphs are temporary objects",
		"Garbage collector wake-up means graph death",
		"text is tab delimited",
		"...and will paste into Excel",
		"dragging wedge rotates laser",
    	"Select camera when changing",
    	"A or F, rho or when: OPENING files!!!",
    	"For updates,bug reports and donations",
    	"E-mail to:",
    	"lyon@cse.bridgeport.edu"
		};

   

	
	Grating grating = new Grating();
	boolean grating_updated = false;
	
	Camera camera = new Camera();
	boolean camera_updated = false;
	
	Laser laser = new Laser();
	boolean laser_updated = false;
	

	
MenuBarFrame(String title) {
	super(title);
	menuBar = new MenuBar();
	setMenuBar(menuBar);
		
	init_menu("Cad",	cad_items);
	init_menu("DSP",	science_items);	
	init_menu("Utils",	batch_items);
	init_menu("Ls",		ls_items);	 
	init_menu("Color",	colors);	
	init_menu("Help",	instructions);	
	
 }
	
 
 
/** init_menu adds a menu named name with a list in list[]
*/
 void init_menu(String name, String list[]) {
 	Menu m = new Menu(name);
	for (int i = 0; i < list.length;i++) {
 		m.add(new MenuItem(list[i]));
 		}
    menuBar.add(m);
}
	
   // Sets pitch of grating and updates scroll-bars
   void setPitch(int v1, int v2) {
   			grating.setPitch(v1,v2);

   			grating_updated = true;
   			System.out.println("you typed "+v1+"and"+v2);
   }
   
   void setLaser(double alpha) {
   			laser.rotation.setValue( alpha);
   			camera_updated = true;
   }


   public void setCamera(double a, double f, double rho) {
   			camera.A.setValue(a);
   			camera.F.setValue(f);
   			camera.rotation.setValue(rho);
   			camera_updated = true;
   }
   

	public boolean handleEvent(Event e) {
	 if (e.target instanceof MenuItem) 
 			ProcessMenuItem.objects(this, e);     		
 	
 	return super.handleEvent(e);
 } 
 
 public boolean action(Event e, Object arg) {
 	repaint();
 	return false;
 }
	
  public void open() { 
 		double data[] = new double[13];     		
    		try {Futil.readDataFile(Futil.getReadFileName(),data);} 
      		catch (Exception exe) 
            		{System.out.println("Error on input file");}
            
           	// you really cant use alpha
           	// directly, it is computed based on
           	// wedge location so
           	// through data[0] away.
           	Laser l = (Laser) Geometry.laser;
      		l.change_config(data[1], data[2]);
      		// set_camera(double a, double f, double rho)
      		// rho = [3], F = [ 7] A = [6]
      		setCamera(data[6],data[7],data[3]);
      		Camera c = (Camera) Geometry.camera;
      		c.change_config(data[4],data[5]); 		
      		Wedge w = (Wedge) Geometry.wedge;
      		w.change_config(data[8],data[9]);
           	setPitch((int) data[10], (int) data[11]); 
           	Grating g = (Grating) Geometry.grating;
      		g.change_config(data[12]);
           	Geometry.compute_rays();
           	repaint();
   	}

}

