package lyon;
import java.applet.Applet;
import java.util.*;
import java.awt.*;
import futils.utils.*;

public class Ray  implements futils.utils.constants {
	public 
		point p1;
		point p2;
		final double pi = Math.PI;

    // slope between two points
    public Ray() {
    	p1 = new point();
    	p2 = new point();
    }
    public Ray(point a, point b) {
    	p1 = new point(a);
    	p2 = new point(b);
    }
    public void print() {
    	System.out.print("Ray:");
    	p1.print();
    	p2.print();
    	System.out.println("Angle is="+r_angle_r());
    	System.out.println("Atan2(p1) = "+atan2(p1));
    	System.out.println("Atan2(p2) = "+atan2(p2));
    	System.out.println("r="+r_angle_d());
    }
    
    public double atan2(point p1) {
    	return to_degrees(Math.atan2(p1.y,p1.x));
    }
    
   public double to_degrees(double d) {
    	return d / Pi_on_180;
    }
    
    public double to_radians(double d) {
    	return d * Pi_on_180;
    }
    
   public point dilation(double t)
    {
    	point pt = new point();
    	pt.x = (1-t) * p1.x + t * p2.x;
    	pt.y = (1-t) * p1.y + t * p2.y;
    	return pt;
    }
    
	public double delta_x() {
		return p2.x - p1.x;
	}
	
	public double delta_y() {
		return p2.y - p1.y;
	}
   
    public double slope() 
     {
      if (delta_x() == 0) {
      	System.out.println("delta_x() == 0 in slope!");
      	}
      return delta_y() / delta_x();
     }	
     
     public void test() {
     	p1.x = 0;
     	p1.y = 0;
     	p2.x = 1;
     	p2.y = 1;
     	print();
     	p2.x=-1;
     	print();
     	p2.y = -1;
     	print();
     	p2.x = 1;
     	print();
     	p1.x = 1;
     	p1.y = 1;
     	p2.x = 2;
     	p2.y = -2;
     	print();
     	for (double i=-1; i < 1; i=i+.1) {
     		System.out.println(Math.asin(i)/Pi_on_180); 
     		}
     	
     }

     
     public double r_angle_d() {
     			return to_degrees(r_angle_r());
     }
     
    public  double r_angle_r()
     {
     	return Math.atan2(delta_y(), delta_x());
     }
   
   // y-intercept, given two points
   public double y_intercept() 
   {
   		double m, x, y;
   		m = slope();
   		// y = mx + b so b = y - mx
   		x = p1.x;
   		y = p1.y;
   		return y - m * x;
   }
} // ray class
